/*!
* @file Authority.h
* @brief 権能のプロトタイプ宣言
* @date 2013/12/22
* @author Deskull
* 2013 Sikabane Works.
*/

#pragma once

#include "stdafx.h"
#include "Deeangband.h"
#include "CreatureTemplate.h"

namespace Deeangband
{

	/*! 
	* @class Authority
	* @brief 権能のクラス
	*/
	class Authority : public CreatureTemplate
	{
	private:

		friend class boost::serialization::access;

		/*!
		* @brief クラスのシリアライズを設定する
		* @param archive アーカイブ化するクラスのアドレス
		* @param version ファイルバージョン
		* @return XMLSerializeテンプレート
		*/
		template<class Archive> void serialize(Archive &archive, const unsigned int version) 
		{
			if(version >= 0)
			{
				archive & boost::serialization::make_nvp("Name", name);
			}
		}

	public:

		/*! 
		* @brief Authorityクラスコンストラクタ
		*/
		Authority::Authority(void);

		/*! 
		* @brief Authorityクラスデストラクタ
		*/
		Authority::~Authority(void);

		/*! 
		* @brief Authorityクラスのデータ消去
		* @return なし
		*/
		void Authority::WipeData(void);

	};
}

BOOST_CLASS_VERSION(Deeangband::Authority, 10);
